#include "OpenGLFunctions.h"	// Hinzugefgt von der Klassenansicht fr m_OpenGL
//folgende zwei Bibliotheken fr die Zeitnahme notwendig, hinzugefgt von S.Wei 
#include <sys/timeb.h>
#include <time.h>

#pragma once

/////////////////////////////////////////////////////////////////////////////
// struct keybordForHexapod, added by S.Wei
typedef union keyboardForHexapod {
 UINT vk_keys[13];	// virtual key code
 struct{
  UINT left;			/* Tastencode fr die Translation nach links      */
  UINT right;			/* Tastencode fr die Translation nach rechts     */
  UINT up;			/* Tastencode fr die Translation nach oben       */
  UINT down;			/* Tastencode fr die Translation nach unten      */
  UINT front;			/* Tastencode fr die Translation nach vorne      */
  UINT back;			/* Tastencode fr die Translation nach hinten     */
  UINT leftback;		/* Tastencode fr die Rotation nach links hinten  */
  UINT rightback;		/* Tastencode fr die Rotation nach rechts hinten */
  UINT backdown;		/* Tastencode fr die Rotation nach hinten unten  */
  UINT frontdown;		/* Tastencode fr die Rotation nach vorne unten   */
  UINT leftdown;		/* Tastencode fr die Rotation nach links unten   */
  UINT rightdown;		/* Tastencode fr die Rotation nach rechts unten  */
  UINT zeroposition;	/* Tastencode fr die Rckkehr in die "0"-Position*/
 };
} HEXAPOD_KEYBOARD, *PHEXAPOD_KEYBOARD, NEAR *NPHEXAPOD_KEYBOARD, FAR *LPHEXAPOD_KEYBOARD;


/////////////////////////////////////////////////////////////////////////////
// CChildView-Fenster

class CChildView : public CWnd
{
// Konstrukter/Destrukter
public:
	CChildView();
	virtual ~CChildView();

// Attribute
public:
	/*following line added by S.Wei, 20.11.2007*/
	static	HEXAPOD_KEYBOARD	keyboard;
	
	
	//static	CChildView*			m_pCChildView;
	
	bool				m_bKeyDown;
	COpenGLFunctions	m_OpenGL;
	

private:
	CPoint				m_MousePosSave;
	bool				isRecording;
	struct __timeb64	startzeit;
	bool				m_bSceneChange;

// Methoden
public:
	//following lines added by S.Wei, last change 12.02.2008
	BOOL PreTranslateMessage(MSG* pMsg);
	void ActionFromInteractionDevice(UINT action, float faktor=1);
	void OnActionCommand(UINT action, float faktor=1); 
	void  setPlattform(float x=0, float y=0, float z=0, float rx=0, float ry=0, float rz=0, UINT step=1);//absolute Plattformpunkt- & -ausrichtungseinstellung
	void movePlattform(float x=0, float y=0, float z=0, float rx=0, float ry=0, float rz=0, UINT step=1);//relative Plattformpunkt- & -ausrichtungsnderung; step gibt den zu bewegenden Anteil an (Beispiel 10 = der 10.Teil der Strecke zurck legen)
	void  setView(float x=0, float y=0, float z=0, float rx=0, float ry=0, float rz=0, UINT step=1);//absoluter Gesichtspunkt & -richtung einstellen
	void moveView(float x=0, float y=0, float z=0, float rx=0, float ry=0, float rz=0, UINT step=1);//relative Gesichtspunkt- & -richtungsnderung
	void  setScene(float x=0, float y=0, float z=0, float rx=0, float ry=0, float rz=0, UINT step=1);//absoluter Modellpunkt & -ausrichtung einstellen
	void moveScene(float x=0, float y=0, float z=0, float rx=0, float ry=0, float rz=0, UINT step=1);//relative Modellpunkt- & -ausrichtungsnderung
	void aktualisieren();//bewegt alle virtuellen und reelen Servo-Motoren (=> Plattformen)
	void recording();	//nimmt die Bewegungen auf
	void setRecording(bool b); //schaltet die Aufnahme frei/ab
	bool getRecording(); //gibt den Aufnahmestatus wieder


	// Generierte Funktionen fr die Nachrichtentabellen
	//{{AFX_MSG(CChildView)
	afx_msg void OnPaint();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnActivate(UINT nState, CWnd *pWndOther, BOOL bMinimized); //added by S.Wei, 13.12.2007
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	//following 2 lines added by S.Wei 03.12.2007
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnKillFocus(CWnd *pNewWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
	// berladungen
	// Vom Klassen-Assistenten erstellte virtuelle Funktionsberladungen
	//{{AFX_VIRTUAL(CChildView)
		virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL


private:
	//following lines added by S.Wei, last change 20.11.2007
	void InitKeyboard();
	void InitCamera();
	
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorherigen Zeile zustzliche Deklarationen ein.

