// DlgLightSettings.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "hexmotion.h"
#include "resource.h"
#include "gl\gl.h"			//OpenGL - Standartbefehle	z.B. glVertex3d(), ...
#include "gl\glu.h"			//OpenGL - Utilities		z.B. gluPerspective(), ...
//#include "gl\glaux.h"		//OpenGL - Hilfsbibliothek	z.B. auxSolidSphere(), ...
#include "OpenGLLight.h"
#include "OpenGLScene.h"
#include "OpenGLFunctions.h"
#include "DlgLightSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgLightSettings 


CDlgLightSettings::CDlgLightSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLightSettings::IDD, pParent)
{	m_bIsActive=false;
	m_bConnected=true;
	//{{AFX_DATA_INIT(CDlgLightSettings)
	m_strSourceList = _T("");
	m_strSourceVarList = _T("");
	m_bConnected = FALSE;
	m_nSlider0 = 0;
	m_nSlider1 = 0;
	m_nSlider2 = 0;
	//}}AFX_DATA_INIT
}


void CDlgLightSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLightSettings)
	DDX_Control(pDX, IDC_SLIDER2, m_ctlSlider2);
	DDX_Control(pDX, IDC_SLIDER1, m_ctlSlider1);
	DDX_Control(pDX, IDC_SLIDER0, m_ctlSlider0);
	DDX_Control(pDX, IDC_SOURCE_VAR_LIST, m_ctlSourceVarList);
	DDX_Control(pDX, IDC_SOURCE_LIST, m_ctlSourceList);
	DDX_CBString(pDX, IDC_SOURCE_LIST, m_strSourceList);
	DDX_CBString(pDX, IDC_SOURCE_VAR_LIST, m_strSourceVarList);
	DDX_Check(pDX, IDC_CONNECT, m_bConnected);
	DDX_Slider(pDX, IDC_SLIDER0, m_nSlider0);
	DDX_Slider(pDX, IDC_SLIDER1, m_nSlider1);
	DDX_Slider(pDX, IDC_SLIDER2, m_nSlider2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgLightSettings, CDialog)
	//{{AFX_MSG_MAP(CDlgLightSettings)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_SOURCE_VAR_LIST, OnSelchangeSourceVarList)
	ON_CBN_SELCHANGE(IDC_SOURCE_LIST, OnSelchangeSourceList)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BTN_ACTIVATE, OnBtnActivate)
	ON_BN_CLICKED(IDC_BTN_ACTIVATE_ALL, OnBtnActivateAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgLightSettings 

void CDlgLightSettings::OnCancel()
{	
	COpenGLScene* pScene = COpenGLFunctions::m_pCOpenGLFunctions->m_pScene;
	CIniFile* INI = CIniFile::m_pCIniFile;
	
	bool DlgModal=false;	//Wurde der Dialog durch DoModal() erzeugt?
	TRACE("CDlgLightSettings::OnCancel()\n");
	KillTimer(ID_UPDATETIMER_LIGHT_SETTINGS);
	m_bIsActive=false;
	
	if (DlgModal)		// Wenn Modal-Dialog erzeugt wurde ( DoModal() )
		EndDialog(0);	
	else				// Wenn Modeless-Dialog erzeugt wurde wurde ( Create(...)+ShowWindow(..) )
		DestroyWindow();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CDlgLightSettings::OnOK()
{	//Ohne Inhalt da Return nicht als Abbruch fr Fenster benutzt wird.
	//Wenn OnOK() nicht berschrieben wird, dann wird dennoch die standart OnOK()-Version ausgefhrt.
	OnCancel();
}

void CDlgLightSettings::UpdateDlg()
{	
	COpenGLScene* pScene = COpenGLFunctions::m_pCOpenGLFunctions->m_pScene;
	CIniFile* INI = CIniFile::m_pCIniFile;

	GetDlgItem(IDC_RAHMEN)->SetWindowText("Settings");

	bool bLightsExist=true;
	if (COpenGLLight::m_pLightList.IsEmpty()) bLightsExist=false;
	
	m_nSource=0;
	if		(m_strSourceList=="GL_LIGHT0")	m_nSource=GL_LIGHT0;
	else if (m_strSourceList=="GL_LIGHT1")	m_nSource=GL_LIGHT1;
	else if (m_strSourceList=="GL_LIGHT2")	m_nSource=GL_LIGHT2;
	else if (m_strSourceList=="GL_LIGHT3")	m_nSource=GL_LIGHT3;
	else if (m_strSourceList=="GL_LIGHT4")	m_nSource=GL_LIGHT4;
	else if (m_strSourceList=="GL_LIGHT5")	m_nSource=GL_LIGHT5;
	else if (m_strSourceList=="GL_LIGHT6")	m_nSource=GL_LIGHT6;
	else if (m_strSourceList=="GL_LIGHT7")	m_nSource=GL_LIGHT7;
	else {	TRACE("wrong Light %s \n",m_strSourceList);
			m_nSource=0;
			//AfxMessageBox("CDlgLightSettings::UpdateDlg()\n\nFehlerhaftes Light",MB_OK+MB_ICONERROR,0);
	};	
	m_nSourceVar=0;
	if		(m_strSourceVarList=="GL_AMBIENT")	m_nSourceVar=GL_AMBIENT;
	else if (m_strSourceVarList=="GL_DIFFUSE")	m_nSourceVar=GL_DIFFUSE;
	else if (m_strSourceVarList=="GL_SPECULAR")	m_nSourceVar=GL_SPECULAR;
	else if (m_strSourceVarList=="GL_POSITION")	m_nSourceVar=GL_POSITION;
	else {	TRACE("wrong LightVar %s \n",m_strSourceVarList);
			m_nSourceVar=0;
			//AfxMessageBox("CDlgLightSettings::UpdateDlg()\n\nFehlerhafte LightVar",MB_OK+MB_ICONERROR,0);
	};
	
	m_pThisLight=COpenGLLight::GetGLLight(m_nSource);

	bool all_active=COpenGLFunctions::m_pCOpenGLFunctions->m_pScene->m_bLight;
	
	bool active;
	if (m_pThisLight) active=m_pThisLight->IsActivated() && all_active;
	else active=false;
	
	if (active)
		GetDlgItem(IDC_BTN_ACTIVATE)->SetWindowText("Ausschalten");
	else
		GetDlgItem(IDC_BTN_ACTIVATE)->SetWindowText("Einschalten");

	GetDlgItem(IDC_SLIDER0)->EnableWindow(active);
	GetDlgItem(IDC_SLIDER1)->EnableWindow(active);
	GetDlgItem(IDC_SLIDER2)->EnableWindow(active);
	GetDlgItem(IDC_RAHMEN)->EnableWindow(active);
	GetDlgItem(IDC_CONNECT)->EnableWindow(active);
	GetDlgItem(IDC_SOURCEVAR_A)->EnableWindow(active);
	GetDlgItem(IDC_SOURCEVAR_B)->EnableWindow(active);
	GetDlgItem(IDC_SOURCEVAR_C)->EnableWindow(active);
	GetDlgItem(IDC_SOURCE_VAR_LIST)->EnableWindow(active);
	
	GetDlgItem(IDC_SOURCE_LIST)->EnableWindow(all_active);
	GetDlgItem(IDC_BTN_ACTIVATE)->EnableWindow(all_active);

	if ((m_nSourceVar==GL_POSITION)&&(m_pThisLight->IsFixed()))
	{	//fr fixiertes Licht muss umweg gemacht werden, da GetLightfv... nur die transformierten Koordinaten liefert
		INI->GetValueTrFloat(m_strSourceList,"position",m_fSourceVar);
		m_fSourceVar[3]=1.0f;
	}
	else
		glGetLightfv(m_nSource,m_nSourceVar,m_fSourceVar);
	
	CString value;
	CString rubrik[3];
	CString dim;
	int SliderMin=0;
	int SliderMax=200;
	float fDisplayScale;
	if ((m_nSourceVar==GL_AMBIENT)||(m_nSourceVar==GL_DIFFUSE)||(m_nSourceVar==GL_SPECULAR))
		{
			rubrik[0]="R=";
			rubrik[1]="G=";
			rubrik[2]="B=";
			dim="%";
			m_fValueMax=1.0;
			m_fValueMin=0.0;
			fDisplayScale=100.0;
		}
	else if (m_nSourceVar==GL_POSITION)	
		{
			rubrik[0]="PosX:";
			rubrik[1]="PosY:";
			rubrik[2]="PosZ:";
			dim="mm";
			m_fValueMax=100.0;
			m_fValueMin=-100.0;
			fDisplayScale=1.0;
		}
	else {
			rubrik[0]="A:";
			rubrik[0]="B:";
			rubrik[0]="C:";
			dim="";
			m_fValueMax=1.0;
			m_fValueMin=0.0;
			fDisplayScale=1.0;
	};
	m_fScale=(m_fValueMax-m_fValueMin)/(SliderMax-SliderMin);
	m_fOffset=m_fValueMin;
		
	value=Convert(m_fSourceVar[0]*fDisplayScale);
	GetDlgItem(IDC_SOURCEVAR_A)->SetWindowText(rubrik[0]+" "+value+" "+dim);

	value=Convert(m_fSourceVar[1]/m_fScale);
	GetDlgItem(IDC_SOURCEVAR_B)->SetWindowText(rubrik[1]+" "+value+" "+dim);
	
	value=Convert(m_fSourceVar[2]/m_fScale);
	GetDlgItem(IDC_SOURCEVAR_C)->SetWindowText(rubrik[2]+" "+value+" "+dim);

	UpdateData(false);
	
	m_ctlSlider0.SetRange(SliderMin,SliderMax);
	m_ctlSlider0.SetPos((int)((m_fSourceVar[0]-m_fOffset)/m_fScale));
	m_ctlSlider1.SetRange(SliderMin,SliderMax);
	m_ctlSlider1.SetPos((int)((m_fSourceVar[1]-m_fOffset)/m_fScale));
	m_ctlSlider2.SetRange(SliderMin,SliderMax);
	m_ctlSlider2.SetPos((int)((m_fSourceVar[2]-m_fOffset)/m_fScale));

	UpdateData(true);
	UpdateData(false);

}

void CDlgLightSettings::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent)
	{	
	case ID_UPDATETIMER_LIGHT_SETTINGS:
		UpdateDlg();
		break;
	};	
	CDialog::OnTimer(nIDEvent);
}

BOOL CDlgLightSettings::OnInitDialog() 
{	//SetTimer(ID_UPDATETIMER_LIGHT_SETTINGS,100,NULL);
	CDialog::OnInitDialog();
	
	COpenGLLight* pLight;
	CString temp;

	if (!COpenGLLight::m_pLightList.IsEmpty())
	{
		POSITION pos=COpenGLLight::m_pLightList.GetHeadPosition();	
		if (pos)
		{	while (pos)
			{	pLight=COpenGLLight::m_pLightList.GetNext(pos);
				m_ctlSourceList.AddString(pLight->GetName());
			}
		}
	}
	else
		m_ctlSourceList.AddString("NO LIGHTS");
	
	m_ctlSourceList.SetCurSel(0);
	m_ctlSourceVarList.SetCurSel(0);
	
	UpdateData(true);	

	UpdateDlg();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}





void CDlgLightSettings::OnSelchangeSourceVarList() 
{	UpdateData(true);
	UpdateDlg();
}

void CDlgLightSettings::OnSelchangeSourceList() 
{	UpdateData(true);
	UpdateDlg();	
}

void CDlgLightSettings::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	CIniFile* INI = CIniFile::m_pCIniFile;
	
	UpdateData(true);							//aktuelle Sliderposition festsetzen

	float vardiff;
	bool ChangeIsOk=false;
	switch (pScrollBar->GetDlgCtrlID())
	{
	case IDC_SLIDER0:
		vardiff=m_fSourceVar[0];
		m_fSourceVar[0]=m_nSlider0*m_fScale+m_fOffset;
		if (m_bConnected)
		{		vardiff=m_fSourceVar[0]-vardiff;
				m_fSourceVar[1]+=vardiff;
				m_fSourceVar[2]+=vardiff;
		}
		ChangeIsOk=true;
	break;
	case IDC_SLIDER1:
		vardiff=m_fSourceVar[1];
		m_fSourceVar[1]=m_nSlider1*m_fScale+m_fOffset;
		if (m_bConnected)
		{		vardiff=m_fSourceVar[1]-vardiff;
				m_fSourceVar[0]+=vardiff;
				m_fSourceVar[2]+=vardiff;
		}
		ChangeIsOk=true;
	break;
	case IDC_SLIDER2:
		vardiff=m_fSourceVar[2];
		m_fSourceVar[2]=m_nSlider2*m_fScale+m_fOffset;
		if (m_bConnected)
		{		vardiff=m_fSourceVar[2]-vardiff;
				m_fSourceVar[0]+=vardiff;
				m_fSourceVar[1]+=vardiff;
		}
		ChangeIsOk=true;
	break;
	};
	
	if (ChangeIsOk)
	{
		for (int n=0;n<=3;n++)
		{
			m_fSourceVar[n]= (m_fSourceVar[n]>=m_fValueMin) ? m_fSourceVar[n] : m_fValueMin;
			m_fSourceVar[n]= (m_fSourceVar[n]<=m_fValueMax) ? m_fSourceVar[n] : m_fValueMax;
		};

		m_pThisLight->SetLightVar(m_nSourceVar,m_fSourceVar);
		pOpenGL->DrawScene();

		CString name=m_pThisLight->GetName();
		CString type;
		
		ASSERT (m_nSourceVar>=0x1200);//GL_AMBIENT
		ASSERT (m_nSourceVar<=0x1209);//GL_QUADRATIC_ATTENUATION
		if		(m_nSourceVar==GL_AMBIENT)	type="ambient";
		else if (m_nSourceVar==GL_DIFFUSE)	type="diffuse";
		else if (m_nSourceVar==GL_SPECULAR) type="specular";
		else if (m_nSourceVar==GL_POSITION) type="position";
	
		INI->SetValue(name,type,m_fSourceVar,true);
		
		UpdateDlg();
	};
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}



void CDlgLightSettings::OnBtnActivate() 
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	CIniFile* INI = CIniFile::m_pCIniFile;

	if (m_pThisLight)
	{	int IniVal=0;
		if (m_pThisLight->IsActivated()) 
		{	m_pThisLight->Activate(false);
			IniVal=0;
		}
		else 
		{	m_pThisLight->Activate(true);
			IniVal=1;
		};
		INI->SetValue(m_pThisLight->GetName(),"active",IniVal,true);
	};
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
	UpdateDlg();
}

void CDlgLightSettings::OnBtnActivateAll() 
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	CIniFile* INI = CIniFile::m_pCIniFile;

	int IniVal=0;
	if (pScene->m_bLight) 
	{	pScene->m_bLight=false;
		IniVal=0;
	}
	else 
	{	pScene->m_bLight=true;
		IniVal=1;
	};
	INI->SetValue("SCENE","lighting",IniVal,true);
	
	UpdateDlg();
	
	pOpenGL->DrawScene();
	
}
