// DlgPlattformSettings.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "hexmotion.h"
#include "OpenGLScene.h"
#include "OpenGLFunctions.h"
#include "Servo.h"
#include "SerialCom.h"
#include "Plattform.h"
#include "DlgPlattformSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgPlattformSettings 


CDlgPlattformSettings::CDlgPlattformSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPlattformSettings::IDD, pParent)
{	m_bIsActive=false;
 ZeroMemory(&m_dPlattformPos,sizeof(float)*11+sizeof(int)*7);
	//{{AFX_DATA_INIT(CDlgPlattformSettings)
/*	m_dPlattformPos_X = 0.0;
	m_dPlattformPos_Y = 0.0;
	m_dPlattformPos_Z = 0.0;
	m_dPlattformOrientation_A = 0.0;
	m_dPlattformOrientation_B = 0.0;
	m_dPlattformOrientation_C = 0.0;
	m_nLinkPointSelect = -1;
	m_dLPx = 0.0;
	m_dLPy = 0.0;
	m_dLPz = 0.0;
	m_nSliderA = 0;
	m_nSliderB = 0;
	m_nSliderC = 0;
	m_nSliderX = 0;
	m_nSliderY = 0;
	m_nSliderZ = 0;
	m_dPlattformIncrTranslation = 0.0;
	m_dPlattformIncrRotation = 0.0;*/
	//}}AFX_DATA_INIT
}


void CDlgPlattformSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPlattformSettings)
	DDX_Control(pDX, IDC_PLATTFORM+2, m_ctlSlider[2]);
	DDX_Control(pDX, IDC_PLATTFORM+1, m_ctlSlider[1]);
	DDX_Control(pDX, IDC_PLATTFORM+0, m_ctlSlider[0]);
	DDX_Control(pDX, IDC_PLATTFORM+5, m_ctlSlider[5]);
	DDX_Control(pDX, IDC_PLATTFORM+4, m_ctlSlider[4]);
	DDX_Control(pDX, IDC_PLATTFORM+3, m_ctlSlider[3]);
	DDX_Control(pDX, IDC_LINKPOINT_LIST, m_ctlLinkPointSelect);
	DDX_Text(pDX, IDC_EDIT_PLATTFORM_POS+0, m_dPlattformPos[0]);
	DDX_Text(pDX, IDC_EDIT_PLATTFORM_POS+1, m_dPlattformPos[1]);
	DDX_Text(pDX, IDC_EDIT_PLATTFORM_POS+2, m_dPlattformPos[2]);
	DDX_Text(pDX, IDC_EDIT_PLATTFORM_POS+3, m_dPlattformOrientation[0]);
	DDX_Text(pDX, IDC_EDIT_PLATTFORM_POS+4, m_dPlattformOrientation[1]);
	DDX_Text(pDX, IDC_EDIT_PLATTFORM_POS+5, m_dPlattformOrientation[2]);
	DDX_CBIndex(pDX, IDC_LINKPOINT_LIST, m_nLinkPointSelect);
	DDX_Text(pDX, IDC_EDIT_LP+0, m_dLP[0]);
	DDX_Text(pDX, IDC_EDIT_LP+1, m_dLP[1]);
	DDX_Text(pDX, IDC_EDIT_LP+2, m_dLP[2]);
	DDX_Slider(pDX, IDC_PLATTFORM+3, m_nSlider[3]);
	DDX_Slider(pDX, IDC_PLATTFORM+4, m_nSlider[4]);
	DDX_Slider(pDX, IDC_PLATTFORM+5, m_nSlider[5]);
	DDX_Slider(pDX, IDC_PLATTFORM+0, m_nSlider[0]);
	DDX_Slider(pDX, IDC_PLATTFORM+1, m_nSlider[1]);
	DDX_Slider(pDX, IDC_PLATTFORM+2, m_nSlider[2]);
	DDX_Text(pDX, IDC_EDIT_PLATTFORM_INCR_TRANSLATION, m_dPlattformIncrTranslation);
	DDX_Text(pDX, IDC_EDIT_PLATTFORM_INCR_ROTATION, m_dPlattformIncrRotation);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgPlattformSettings, CDialog)
	//{{AFX_MSG_MAP(CDlgPlattformSettings)
	ON_BN_CLICKED(IDC_BTN_PLATTFORM_UPDATE, OnBtnPlattformUpdate)
	ON_CBN_SELCHANGE(IDC_LINKPOINT_LIST, OnSelchangeLinkpointList)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgPlattformSettings 

void CDlgPlattformSettings::OnCancel()
{	bool DlgModal=false;	//Wurde der Dialog durch DoModal() erzeugt?
	
	m_bIsActive=false;	

	if (DlgModal)		// Wenn Modal-Dialog erzeugt wurde ( DoModal() )
		EndDialog(0);	
	else				// Wenn Modeless-Dialog erzeugt wurde wurde ( Create(...)+ShowWindow(..) )
		DestroyWindow();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CDlgPlattformSettings::OnOK()
{
	OnBtnPlattformUpdate();
}

void CDlgPlattformSettings::UpdateDlg()
{
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	CPlattform* pPlattform;
	
	UpdateData(true);
	
	pPlattform=CPlattform::m_pCPlattform;
	
	bool doit=false;
	if (pPlattform) doit=true;

	GetDlgItem(IDC_EDIT_PLATTFORM_POS+0)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_PLATTFORM_POS+1)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_PLATTFORM_POS+2)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_PLATTFORM_POS+3)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_PLATTFORM_POS+4)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_PLATTFORM_POS+5)->EnableWindow(doit);	
	GetDlgItem(IDC_BTN_PLATTFORM_UPDATE)->EnableWindow(doit);	

	float fTemp[4];
	
	if (pPlattform)	
	{
		pPlattform->GetPosition(m_dPlattformPos);
		Round(m_dPlattformPos,2);
		pPlattform->GetOrientation(m_dPlattformOrientation);
		Round(m_dPlattformOrientation,2);
		
		pPlattform->GetLinkPointLokal(m_nLinkPointSelect+1,m_dLP);
		Round(m_dLP,2);

		UpdateData(false);
		pPlattform->GetPosition(fTemp);
		m_ctlSlider[0].SetPos((int)((fTemp[0]-m_fPosOffset[0])*10.0f+100.0f));
		m_ctlSlider[1].SetPos((int)((fTemp[1]-m_fPosOffset[1])*10.0f+100.0f));
		m_ctlSlider[2].SetPos((int)((fTemp[2]-m_fPosOffset[2])*10.0f+100.0f));
		pPlattform->GetOrientation(fTemp);
		m_ctlSlider[3].SetPos((int)(fTemp[0]+50.0f));
		m_ctlSlider[4].SetPos((int)(fTemp[1]+50.0f));
		m_ctlSlider[5].SetPos((int)(fTemp[2]+50.0f));

		UpdateData(true);
		UpdateData(false);

		pOpenGL->DrawScene();
	};
	UpdateData(false);
}

void CDlgPlattformSettings::OnBtnPlattformUpdate() 
{
	//COpenGLScene* pScene =  COpenGLFunctions::m_pCOpenGLFunctions->m_Scene;
	//COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	CServo* pServo=NULL;
	CPlattform* pPlattform;
	UpdateData(true);

	pPlattform=CPlattform::m_pCPlattform;
	if (pPlattform)
	{	pPlattform->SetPosition(m_dPlattformPos);
	
		pPlattform->SetOrientation(m_dPlattformOrientation);

		pPlattform->SetLinkPointLokal(m_nLinkPointSelect+1,m_dLP);
		pPlattform->m_dIncrRotation=m_dPlattformIncrRotation;
		pPlattform->m_dIncrTranslation=m_dPlattformIncrTranslation;
	};
	bool MoveServo=true;
	int n;
	for (n=1;n<=6;n++)
	{	//pServo=CServo::GetServo(n);
		//if (!(pServo->CalcConnection()))
		if (!CServo::GetServo(n)->CalcConnection())
			MoveServo=false;				
	}
	
	if (MoveServo)
		for (n=1;n<=6;n++)
			CServo::GetServo(n)->MoveRealServo();
	UpdateDlg();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();		
}

BOOL CDlgPlattformSettings::OnInitDialog() 
{	CDialog::OnInitDialog();

	m_fPosOffset[0]=0.0f;
	m_fPosOffset[1]=15.0f;
	m_fPosOffset[2]=0.0f;
	
	m_ctlLinkPointSelect.SetCurSel(0);
	UpdateData(true);
	
	m_ctlSlider[0].SetRange(0,200);
	m_ctlSlider[1].SetRange(0,200);
	m_ctlSlider[2].SetRange(0,200);
	m_ctlSlider[3].SetRange(0,100);
	m_ctlSlider[4].SetRange(0,100);
	m_ctlSlider[5].SetRange(0,100);
	UpdateData(false);
	
	if (CPlattform::m_pCPlattform)
	{	m_dPlattformIncrTranslation=CPlattform::m_pCPlattform->m_dIncrTranslation;
		m_dPlattformIncrRotation=CPlattform::m_pCPlattform->m_dIncrRotation;
	} else
	{	m_dPlattformIncrTranslation=0.0;
		m_dPlattformIncrRotation=0.0;	
	};
	UpdateData(false);
	UpdateDlg();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgPlattformSettings::OnSelchangeLinkpointList() 
{	UpdateDlg();
}

void CDlgPlattformSettings::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	CPlattform* pPlattform=NULL;
	CServo* pServo=NULL;

	UpdateData(true);
	pPlattform=CPlattform::m_pCPlattform;

 if (nSBCode!=8) {
  switch (pScrollBar->GetDlgCtrlID()) {
   case IDC_PLATTFORM+0: m_dPlattformPos[0]=m_fPosOffset[0]+(m_nSlider[0]-100.0f)/10.0f; break;
   case IDC_PLATTFORM+1: m_dPlattformPos[1]=m_fPosOffset[1]+(m_nSlider[1]-100.0f)/10.0f; break;
   case IDC_PLATTFORM+2: m_dPlattformPos[2]=m_fPosOffset[2]+(m_nSlider[2]-100.0f)/10.0f; break;
   case IDC_PLATTFORM+3: m_dPlattformOrientation[0]=m_nSlider[3]-50.0f; break;
   case IDC_PLATTFORM+4: m_dPlattformOrientation[1]=m_nSlider[4]-50.0f; break;
   case IDC_PLATTFORM+5: m_dPlattformOrientation[2]=m_nSlider[5]-50.0f; break;
  }
  pPlattform->SetPosition(m_dPlattformPos);
  pPlattform->SetOrientation(m_dPlattformOrientation);
 }
	
	bool MoveServo=true;
	int n;
	for (n=1;n<=6;n++)
	{	//pServo=CServo::GetServo(n);
		//if (!(pServo->CalcConnection()))
		if (!CServo::GetServo(n)->CalcConnection())
			MoveServo=false;				
	}
	
	if (MoveServo)
		for (n=1;n<=6;n++)
			CServo::GetServo(n)->MoveRealServo();
	UpdateDlg();
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDlgPlattformSettings::MoveServo(int nServoNr, int nValue) {
// Schon wieder dieselbe Scheie!
 char buf[8];
 gApp.m_SerialCom.WriteBytes(buf,wnsprintfA(buf,elemof(buf),"(m%d%03d)",nServoNr,nValue));
}