// HexMotion.h : Haupt-Header-Datei fr die Anwendung HEXMOTION
#pragma once
#ifndef __AFXWIN_H__
# error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"   // Hauptsymbole (Quatsch! Nur Symbole von Ressource sollen da rein!)
#include "SerialCom.h"	// Hinzugefgt von der Klassenansicht
#include "IniFile.h"	// Hinzugefgt von der Klassenansicht

/////////////////////////////////////////////////////////////////////////////
// CHexMotionApp:
// Siehe HexMotion.cpp fr die Implementierung dieser Klasse
//

//-----------------DEFINE---INSTANCE-POINTER------------------
//getInstancePointer 
#define IP_GET(art)		gApp.getInstancePointer(art)
#define IP_GETN(art,n)		gApp.getInstancePointer(art, n)
#define IP_GETNAMED(art,n,name)	gApp.getInstancePointer(art, n, name)
//setInstancePointer
#define IP_SET(art,ptr)		gApp.setInstancePointer(art, ptr)
#define IP_SETN(art, ptr, n)	gApp.setInstancePointer(art, ptr, n)
#define IP_SETNAMED(art,ptr,n,name) gApp.setInstancePointer(art, ptr, n, name)
//getInstancePointerCount
#define IP_COUNT(art)		gApp.getInstancePointerCount(art)
#define IP_COUNTNAMED(art,name)	gApp.getInstancePointerCount(art, name)


// --- globale Funktionen ---
void TrimValue(	float &  value,	float  min,	float  max,bool bAbsolut=false);
void TrimValue(	int &    value,	int    min,	int    max,bool bAbsolut=false);
//void TrimValue(	double & value,	double min,	double max,bool bAbsolut=false);
float Round(float value,int Nachkommastellen=0);	//Konvertiert float->double mit Nachkommastellen-Anzahl
void Round(float value[3], int nk, int len=3);
CString Convert(float number);
float GetVektorWinkel(const float MP[3], const float P1[3], const float P2[3]);

//double sqr(double);
float sqr(float);
float EyeAngle(const float pointOfObject[3], const float pointOfView[3], float eyeoffset);		//added by S.Wei 21.12.2007

typedef struct {
 CWnd * ptr;
 CString name;
 int number;
}NamedpWnd;


class CHexMotionApp : public CWinApp {
//Konstruktor
public:
 CHexMotionApp();

//Attribute
public:
 CIniFile	m_IniFile;
 CSerialCom	m_SerialCom;
	
	//Umstellung auf zentrale Verwaltung anstatt statischer Zeiger auf Instanzen
	// S.Wei, 07.12.2007
//Kontrollklassen

//Anzeigeklassen
 CList <NamedpWnd,NamedpWnd&> m_pWnd;


//Methoden
private:
 BOOL _Vorauswertung(CString &name, int &n);
public:
 int setInstancePointer(CString art, void * ptr, int n = 0, CString name = "");
 void * getInstancePointer(CString art, int n = 0, CString name = "");
 int getInstancePointerCount(CString art, CString name = "");
 BOOL deleteInstancePointer(CString art, int n, CString name = "");
	//{{AFX_VIRTUAL(CHexMotionApp)
public:
 virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CHexMotionApp)
 afx_msg void OnAppAbout();
		// HINWEIS - An dieser Stelle werden Member-Funktionen vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG
 DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}

extern CHexMotionApp gApp;
