//Joystick.h - Headerdatei fr Joystick.cpp
/**	Diese Klasse CJoystick liefert die bentigten Methoden, um unter Windowssystemen einen Joystick zu nutzen.
	Sie ist auf die Verwendung durch Hexapod/Hexmotion zugeschnitten worden.
	Ausgegliedert: S.Wei 20.11.2007

	Zu beachten: Entsprechend der Implementierung greift die Klasse auf die Methode ActionFromInteractionDevice der Klasse CChildView zu.
*/


#include <windows.h>
#include <mmsystem.h>

#include <math.h>

#pragma once

//define for std-Joystick
#define JOY_POSITION_X_MIN              0
#define JOY_POSITION_X_NULL             32768
#define JOY_POSITION_X_MAX				65536
#define JOY_THRESHOLD_X                 3072
#define JOY_POSITION_Y_MIN              0
#define JOY_POSITION_Y_NULL             32768
#define JOY_POSITION_Y_MAX				65536
#define JOY_THRESHOLD_Y                 3072

#define NOJOYSTICK						-1

/////////////////////////////////////////////////////////////////////////////
// struct joystickForHexapod
typedef struct joystickForHexapod
{
	JOYCAPS	  joycaps;		/**/
	JOYINFOEX left;			/* Joystickcode fr die Translation nach links      */
    JOYINFOEX right;		/* Joystickcode fr die Translation nach rechts     */
    JOYINFOEX front;		/* Joystickcode fr die Translation nach vorne      */
    JOYINFOEX back;			/* Joystickcode fr die Translation nach hinten     */
	JOYINFOEX up;			/* Joystickcode fr die Translation nach oben       */
    JOYINFOEX down;			/* Joystickcode fr die Translation nach unten      */
    JOYINFOEX leftdown;		/* Joystickcode fr die Rotation nach links unten   */
    JOYINFOEX rightdown;	/* Joystickcode fr die Rotation nach rechts unten  */
    JOYINFOEX frontdown;	/* Joystickcode fr die Rotation nach vorne unten   */
    JOYINFOEX backdown;		/* Joystickcode fr die Rotation nach hinten unten  */
    JOYINFOEX leftback;		/* Joystickcode fr die Rotation nach links hinten  */
    JOYINFOEX rightback;	/* Joystickcode fr die Rotation nach rechts hinten */
    JOYINFOEX zeroposition;	/* Joystickcode fr die Rckkehr in die "0"-Position*/
} HEXAPOD_JOYSTICK, *PHEXAPOD_JOYSTICK, NEAR *NPHEXAPOD_JOYSTICK, FAR *LPHEXAPOD_JOYSTICK;


class CJoystick
{
//Konstruktoren/Destruktor
public:
	CJoystick();
	virtual ~CJoystick();

//Attribute
public:
	static	CJoystick*	m_pCJoystick;	// Was ist das blo fr 'ne Scheie!!! (heha, 02/09)
	static	bool		JoyThreadAlive;
	static	bool		JoyThreadIsRunning;
	static	UINT		sleepTime;
	
	float	m_fTranslationFaktor;
	float	m_fRotationFaktor;
	UINT	m_sleepTime;
	
private:
	CWinThread		*joyThread;
	UINT			m_suspendTime;
	UINT			lastErrorJoystickID;
//Methoden
public:
	void StartJoystick();
	void StopJoystick();
	void JoyStick();
	static UINT _cdecl SeparateRoutineForJoystick(LPVOID pParam);
private:
	void InitJoystick();
	void Joy2Axes4ButtonsOnly(JOYINFOEX joyInfo, JOYCAPS joycaps);
};
