#include "DlgPlattformSettings.h"	// Hinzugefgt von der Klassenansicht
#include "DlgObjectSettings.h"	// Hinzugefgt von der Klassenansicht
#include "DlgLightSettings.h"	// Hinzugefgt von der Klassenansicht
#include "DlgSceneSettings.h"	// Hinzugefgt von der Klassenansicht

#pragma once

#include "ChildView.h"
#include "View2.h"				//added by S.Wei, 03.12.2007
#include "DlgObjectSettings.h"	// Hinzugefgt von der Klassenansicht
#include "DlgStrgSettings.h"	// Hinzugefgt von der Klassenansicht
#include "DlgStrgServoTester.h"	// Hinzugefgt von der Klassenansicht
#include "DlgSceneNavigation.h"	// Hinzugefgt von der Klassenansicht
#include "DlgServoSettings.h"	// Hinzugefgt von der Klassenansicht
#include "DlgServoSettings.h"	// Hinzugefgt von der Klassenansicht
#include "DlgConfigKeyboard.h"  //added by S.Wei 30.08.2007
#include "DlgConfigJoystick.h"  //added by S.Wei 10.09.2007
#include "DlgInfo3DMaus.h"		//added by S.Wei 17.09.2007
#include "3DFehlerMeldung.h"


//define for NULL-Position
#define ZERO_XPOS                       0
#define ZERO_YPOS                       21
#define ZERO_ZPOS                       0
#define ZERO_XROT                       0
#define ZERO_YROT                       0
#define ZERO_ZROT                       0

typedef struct tagFrameSetup
{
	bool menuon;
} FRAME_SETUP;

typedef struct tagFullScreenData
{
	bool isFullScreen;
	bool get3D;
	bool is3D;
	BOOL visibleToolBar;
	BOOL visibleToolBar2;
	BOOL visibleStatusBar;
	long oldWindowStyle;
	HMENU menu;
} FullScreenData;

class CMainFrame : public CFrameWnd
{
//Konstrukter / Destrukter
public:
	CMainFrame();
	virtual ~CMainFrame();
	
protected: 
	DECLARE_DYNAMIC(CMainFrame)

public:
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

//Attribute
public:
	//static	CMainFrame* m_pCMainFrame;

	WINDOWPLACEMENT m_wpPrev;
	
	CDlgPlattformSettings m_DlgPlattformSettings;
	CDlgServoSettings m_DlgServoSettings;
	CDlgObjectSettings m_DlgObjectSettings;
	CDlgLightSettings m_DlgLightSettings;
	CDlgSceneNavigation m_DlgSceneNavigation;
	CDlgStrgServoTester m_DlgStrgServoTester;
	CDlgStrgSettings m_DlgStrgSettings;
	CDlgSceneSettings m_DlgSceneSettings;
	CDlgConfigKeyboard m_DlgConfigKeyboard; //added by S.Wei, 30.08.2007
	CDlgConfigJoystick m_DlgConfigJoystick; //added by S.Wei, 10.09.2007
	DlgInfo3DMaus dlgInfo3DMaus;			//added by S.Wei, 17.09.2007
 	C3DFehlerMeldung m_3DFehlermeldung;		//added by S.Wei, 20.12.2007
	CView2 m_View1;							//added by S.Wei, 13.12.2007
	CView2 m_View2;							//added by S.Wei, 03.12.2007
	
	unsigned int m_nBtnSelected;
	FullScreenData fullscreenData;

// Methoden
public:
	void OnUartCommand(CString Command);
	
	void dualView(bool);
	void switch3DMode();

	void OnMenu(UINT nCmdID);
	void OnMenuUpdate(CCmdUI* pCmdUI);
	
	void OnToolBar(UINT nCmdID);
	void OnToolBarUpdate(CCmdUI *pCmdUI);
	
	void OnToolBar2(UINT nCmdID);
	void OnToolBar2Update(CCmdUI *pCmdUI);

	void FullScreen();
	void FullScreen(bool b);

	void CALLBACK Timer(HWND hWnd, UINT nMsg, UINT_PTR nIDEvent, DWORD dwTime);
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:  // Eingebundene Elemente der Steuerleiste
	CChildView			m_wndView;
	//Umstellung auf Zeiger durch S.Wei, 21.11.2007
	CStatusBar*			m_wndStatusBar;
	CToolBar*			m_wndToolBar;
	CToolBar*			m_wndToolBar2;
		

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnActivate(UINT nState, CWnd *pWndOther, BOOL bMinimized);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	FRAME_SETUP oldFrameSetup;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

