#include "OpenGLScene.h"	// Hinzugefgt von der Klassenansicht
#pragma once

//////////////////////////////////////////////////////////////////////
// OpenGLFunctions.h: Schnittstelle fr die Klasse COpenGLFuctions.	//
// Written by Matthias Weber	wmat@mbv.tu-chemnitz.de  02/2003	//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// COpenGLFunctions.h: COpenGLFunctions-Klasse						//
//																	//
// Bedienungsanleitung:			erstellt von Weber Matthias 03/2003	//
//																	//
// ----------------------------------------------------------------	//
// ntige LIB's -> in Projekteinstellungen eintragen:				//
//		opengl32.lib glu32.lib glaux.lib							//
//																	//
// ----------------------------------------------------------------	//
// Instanz der Klasse erzeugen: im HeaderFile der Basisklasse 		//
//		COpenGLFunctions m_OpenGL									//
//																	//
// ----------------------------------------------------------------	//
// Initialisierung:  in OnCreate() der Basisklasse (CWnd)			//
//		m_OpenGL.m_hWnd=m_hWnd;										//
//		m_OpenGL.m_pDC = new CClientDC(this);						//
//		m_OpenGL.Init();											//
//																	//
// ----------------------------------------------------------------	//
// Aufrufe: in OnPaint() der Basisklasse (CWnd)						//
//		m_OpenGL.DrawScene();										//
//																	//
// ----------------------------------------------------------------	//
//																	//
//////////////////////////////////////////////////////////////////////

#include <afxtempl.h> //fr Templates, hier CList


typedef struct tagOpenGLWndStruct
{
	CClientDC * m_pDC;
	HWND		m_hWnd;
	HDC			m_hDC;
} OpenGLWnd;


class COpenGLFunctions
{
public:
	bool IncludeSTLGeometry(CString path);
	COpenGLFunctions();
	virtual ~COpenGLFunctions();

	static	COpenGLFunctions* m_pCOpenGLFunctions;
	
	COpenGLScene* m_pScene;

	float m_eyeangle;
	float m_eyeoffset;

private:
	CList <OpenGLWnd,OpenGLWnd&> m_lpWnd;

	CClientDC * m_pDC;
	HWND		m_hWnd;
	HDC			m_hDC;
	HGLRC		m_hRC;

public:
	void	Init(CWnd * pWnd);
	void	DrawScene(void);
	//following lines added by S.Wei, 13.12.2007
	void	makeCurrent(CWnd * pWnd);
	void	createNewView(CWnd * pWnd);

protected:
	bool	SetupPixelFormat(void);
	void	InitView(void);
	void	ReSizeView();//int width,int heigth);
	//following lines added by S.Wei, 13.12.2007
	void	protectedDrawScene(CWnd * pWnd);
};
