#pragma once

class COpenGLObject  
{
public:
	CString GetStatus();
	void SetColor(const float color[4]);
	void SetOrientationOffset(const float offset[3]);
	void SetOrientation(const float orientation[3]);
	void SetPositionOffset(const float offset[3]);
	void SetPosition(const float pos[3]);
	CString GetGeometrieFile();
	bool GetShowOrigin();
	bool GetShowGeometry();
	void SetShowOrigin(bool doit);
	void SetShowGeometrie(bool doit);
	void GetColor(float x[4]) const;
	void GetPosition(float x[3]) const;
	void GetPositionOffset(float x[3]) const;
	void GetOrientation(float x[3]) const;
	void GetOrientationOffset(float x[3]) const;
	
	void MoveToPosition();
	
	static COpenGLObject* GetObject(CString strName);	//liefert Pointer auf benannte Instanz
	static COpenGLObject* GetObject(int nObjectNr);		//liefert Pointer auf benannte Instanz
	int GetObjectNumber();
	COpenGLObject(CString strName, CString strStatus="passiv");
	void SetColor(float r, float g, float b, float alpha=1.0f);
	void DrawObjectDummy();
	void SetGeometrie(CString strFileName);
	void SetName(CString strName);
	CString GetName();
	void SetOrientation(float a,float b,float c);
	void SetOrientationOffset(float a,float b,float c);
	void SetPosition(float x,float y,float z);
	void SetPositionOffset(float x, float y, float z);
	void Draw();
	COpenGLObject();
	virtual ~COpenGLObject();

	static CList<COpenGLObject*,COpenGLObject*> m_pObjectList;

	

private:
	CString m_strStatus;
	CString m_strGeometrieFile;
	bool	m_bShowGeometrie;
	bool	m_bShowOrigin;
	float	m_fColor[4];
	float	m_fPosition[3];
	float	m_fPositionOffset[3];
	
	float	m_fOrientation[3];
	float	m_fOrientationOffset[3];
	
	int		m_nObjectNumber;
	CString	m_strName;
	int		m_nListNumber;	//erzeugen mit glGenLists(Anzahl)   testen mit glIsList(List)
};
