#pragma once

//////////////////////////////////////////////////////////////////////
// Verbrochen von: Matthias Weber	wmat@mbv.tu-chemnitz.de  02/2003	//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// COpenGLScene.h: COpenGLScen-Klasse								//
//																	//
// Bedienungsanleitung:			erstellt von Weber Matthias 03/2003	//
//																	//
// ----------------------------------------------------------------	//
// Diese Klasse repressentiet die Basisklasse fr die 				//
// darzustellenden Szeneninhalt.									//
// Es werden alle Variablen, die fr die Szenenbeschreibung			//
// bereitgestellt.													//
//																	//
//																	//
//																	//
//////////////////////////////////////////////////////////////////////


class COpenGLScene
{
public:
//	CCalcConnection m_CalcConnection;
	void InitPlattform();
	void InitServos();
	void InitObjects();
	void DrawFixedLights();
	void AddLight(int nGLLightNr);
	void SetMaterial();
	void DrawObjects();

	void DrawGrids();
	void DrawMarkers();
	void DrawLights();
	void InitVariables();
	void SetViewPoint(int nVP);
	void InitViewPoints();
	float m_fViewPoint[4][12];				// Speicher fr 4 ViewPoints
	void InitMarkers();
	float			m_fColor_SceneBackground[3];
	float			m_fColor_Markers[3];
	float			m_fColor_Grid[3][3];
	
	bool			m_bLight;	
	bool			m_bShowAllMarkers;

	unsigned int	m_nShowSettings;
	int				m_nMouseUsage;

	void InitGrids();

	int		m_nSceneGridList[5];
	int		m_nSceneMarkerList[5];
	
	float m_fSceneAngle[3];
	float m_fScenePosition[3];
	float m_fViewAngle[3];
	float m_fViewPosition[3];
	void Init();
	void Draw();
	COpenGLScene();
	virtual ~COpenGLScene();
	//static	COpenGLScene* m_pCOpenGLScene;//entfernt S.Wei 04.12.2007
private:
	void DrawLinkDebug();
	void DrawPlattformDebug();
	void DrawServoDebug();
};
