#pragma once

class CPlattform {
public:
 CPlattform();
 virtual ~CPlattform();
 static CPlattform* m_pCPlattform;

 void	SetOrientation(const float orientation[3]);	// Einstellen der Plattformausrichtung (winkel)
 void	SetOrientation(float a,float b,float c);	// Einstellen der Plattformausrichtung (winkel)
 void	SetPosition(const float pos[3]);		// Einstellen der Plattformposition (abstnde)
 void	SetPosition(float x,float y,float z);		// Einstellen der Plattformposition (abstnde)
	
 void	GetOrientation(float orientation[3]) const;	// liefert die Plattformausrichtung (winkel)
 void	GetPosition(float pos[3]) const;			// liefert die Plattformposition (abstnde)
 void	GetLinkPointLokal(int P,float pos[3]) const;	// liefert lokale Koordinaten des Linkpointes P
 void	GetLinkPointGlobal(int P,float pos[3]) const;	// liefert globale Koordinaten des Linkpointes P
 void	SetLinkPointLokal(int P,float x,float y,float z);	// setzt benannten LinkPoint (lokales Koordinatensystem)
 void	SetLinkPointLokal(int P,const float v[3]);
 float	m_dIncrTranslation;				// Incremente bei Tastatursteuerung fr Translation
 float	m_dIncrRotation;				// Incremente bei Tastatursteuerung fr Rotation
private:
 void	UpdateLinkPointGlobal();
 void	InitPlattformObjects();				// initialisiert Objekte (pos/orient/geometrie/....)
 void	UpdatePlattformObjects();			// aktualisert Position und Orientierung der Objekte

 float	m_fLinkPointGlobal[6][3];			// Aufhngepunkte in Szenenkoordinaten
 float	m_fLinkPointLokal[6][3];			// Aufhngepunkte in Plattformkoordinaten

 float	m_fOrientation[3];
 float	m_fPosition[3];
};
