//////////////////////////////////////////////////////////////////////
// SerialCom.cpp: implementation of the CSerialCom class			//
// Written by Matthias Weber	wmat@mbv.tu-chemnitz.de  02/2003	//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// SerialCom.cpp: CSerialCom-Klasse									//
//																	//
// Bedienungsanleitung:			erstellt von Weber Matthias 03/2003	//
//																	//
// ----------------------------------------------------------------	//
//   - SerialCom.h + SerialCom.cpp ins Projektverzeichnis kopieren	//
//   - zum Projekt hinzufgen										//
//	 - #include "SerialCom.h" hinzufgen wo ntig					//
//   - CSerialCom-Instanz erzeugen									//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SerialCom.h"
#include "hexmotion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//CSerialCom* CSerialCom::m_pSerialCom;	//static pointer auf instanz 

CSerialCom::CSerialCom() {
	TRACE("CSerialCom::CSerialCom()\n");
	lstrcpy(m_strPortName,"COM?");
	m_nConnectionPort=0;
}

CSerialCom::~CSerialCom()
{	TRACE("CSerialCom::~CSerialCom()\n");
	ClosePort();
}


void CSerialCom::ClosePort() {
 if (hComm) {
  CloseHandle(hComm);
  hComm = 0;
 };
 lstrcpy(m_strPortName,"COM?");
 m_nConnectionPort=0;
// Was kommt denn hier fr eine Kacke hoch!!
 CWnd *p=(CWnd*)IP_GET("m_pCMainFrame");
 if (p) p->KillTimer(ID_UPDATETIMER_UART);
}

bool CSerialCom::ConfigurePort(LPCTSTR s) {
 DCB dcb;
 dcb.DCBlength = sizeof(dcb);
 if (!GetCommState(hComm, &dcb)
 || !BuildCommDCB(s,&dcb)
 || !SetCommState(hComm, &dcb)) {
  TRACE("CSerialCom::ConfiguerPort:Fehler");
  return false;
 }
 return true;
}

bool CSerialCom::OpenPort(int Port) {
 Port=SelectPortNr(Port);
 if (!Port) return false;
 TCHAR buf[12];
 _stprintf(buf,"\\\\.\\COM%u",Port);
 hComm = CreateFile(buf,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,0);
 if (hComm==INVALID_HANDLE_VALUE) {
  AfxMessageBox("CSerialCom::OpenPort()\n\nFehler beim ffnen von "+CString(buf+4)+".\nPort closed...",MB_OK+MB_ICONERROR);
  return false;
 }
 if (!(ConfigurePort(_T("9600,n,8,1")))) {
  AfxMessageBox("CSerialCom::OpenPort()\n\nFehler bei ConfigurePort() fr "+CString(buf+4)+".\nPort closed...",MB_OK+MB_ICONERROR);
  ClosePort();
  return false;
 }
 COMMTIMEOUTS to={0,100,0,0,0};
 if (!SetCommTimeouts(hComm,&to)) {
  TRACE("CSerialCom::OpenPort()\n\nFehler bei SetCommunicationTimeOuts()");
  ClosePort();
  return false;
 }
 lstrcpy(m_strPortName,buf+4);
 m_nConnectionPort=Port;
// Noch so eine Kacke!
 ((CWnd*)IP_GET("m_pCMainFrame"))->SetTimer(ID_UPDATETIMER_UART,100,NULL);
 return true;
}

bool CSerialCom::WriteBytes(const BYTE *s, DWORD n) const {
 if (!WriteFile(hComm,s,n,&n,NULL)) {
  AfxMessageBox("CSerialCom::WriteByte()\n\nFehler beim Schreiben.",MB_OK+MB_ICONERROR,0);
  return false;
 }
 return true;
}

bool CSerialCom::WriteByte(BYTE c) const {
 return WriteBytes(&c);
}

bool CSerialCom::ReadByte(BYTE &c) const {
 DWORD br;
 if (ReadFile(hComm,&c,1,&br,NULL) && br==1) return true;
 return false;
}


bool CSerialCom::IsPortAvailable(int port) {
 HANDLE hPort;
 TCHAR buf[12];
 _stprintf(buf,_T("\\\\.\\COM%d"),port);	
 hPort = CreateFile(buf,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,0);
 if (hPort == INVALID_HANDLE_VALUE) return false;
 CloseHandle(hPort);
 return true;
}

DWORD CSerialCom::GetAvailablePorts() {
 DWORD r=0;
 for (int port=0;port<32;port++) {
  if (IsPortAvailable(port+1)) r|=1<<port;
 };
 return r;
}

// Liefert verfgbares COM-Port (1..32) ausgehend vom angegebenen Wunsch-COM-Port (1..32)
// 0 wenn nicht verfgbar oder bei Benutzerabbruch
int CSerialCom::SelectPortNr(int port) {
 DWORD avail=GetAvailablePorts();
 if (!avail) {
  AfxMessageBox(_T("Es ist kein serielles Port COM1 .. COM32 verfgbar!"),MB_OK|MB_ICONERROR);
  return 0;
 }
 if (avail&(1<<(port-1))) return port;	// Wunschport direkt verfgbar: keine Messagebox
 int r;
 for (r=1; !(avail&1); r++, avail>>=1);	// findet LSB entsprechend bsf-Assemblerbefehl
 TCHAR s[128];
 _stprintf(s,_T("Angegebenes COM%u ist nicht verfgbar.\nStattdessen COM%u verwenden?"),port,r);
 if (AfxMessageBox(s,MB_YESNO|MB_ICONQUESTION)==IDYES) return r;
 return 0;
}
