#pragma once

//////////////////////////////////////////////////////////////////////
// SerialCom.h: interface for the CSerialCom class					//
// Written by Matthias Weber	wmat@mbv.tu-chemnitz.de  02/2003	//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// SerialCom.h: CSerialCom-Klasse									//
//																	//
// Bedienungsanleitung:			erstellt von Weber Matthias 03/2003	//
//																	//
// ----------------------------------------------------------------	//
//   - SerialCom.h + SerialCom.cpp ins Projektverzeichnis kopieren	//
//   - zum Projekt hinzufgen										//
//	 - #include "SerialCom.h" hinzufgen wo ntig					//
//   - CSerialCom-Instanz erzeugen									//
//////////////////////////////////////////////////////////////////////

class CSerialCom// : public CWnd
{
public:
 CSerialCom();
 ~CSerialCom();

 bool	ReadByte(BYTE&) const;
 bool	WriteByte(BYTE) const;
 bool	WriteBytes(const BYTE *pBytes, DWORD n=1) const;
 bool	WriteBytes(const char *s, int n=1) const {return WriteBytes((const BYTE*)s,(DWORD)n);};
	
 bool	OpenPort(int ComPortNr);
 void	ClosePort();

 static DWORD GetAvailablePorts();			//Liefert alle verfgbaren ComPorts (bis 32)
 int GetConnectionPort() const	{return m_nConnectionPort;};
 bool	IsConnected()	const	{return hComm!=0;};
 CString GetName()	const	{return m_strPortName;};
 
private:
 bool	ConfigurePort(LPCTSTR);
 static bool	IsPortAvailable(int port);		//Liefert Verfgbarkeit des Ports
 int		SelectPortNr(int port);
	
 HANDLE	hComm;
 int	m_nConnectionPort;
 TCHAR	m_strPortName[8];
};
