/*-----------------------------------------------------------------------------
 *
 * siapp.h -- Si static library interface header file
 *
 * $Id: siapp.h,v 1.3 2001/01/16 01:18:49 HJin Exp $
 *
 * Contains function headers and type definitions for siapp.c.
 *
 *-----------------------------------------------------------------------------
 *
 * (c) 1998-2005 3Dconnexion. All rights reserved. 
 * Permission to use, copy, modify, and distribute this software for all
 * purposes and without fees is hereby grated provided that this copyright
 * notice appears in all copies.  Permission to modify this software is granted
 * and 3Dconnexion will support such modifications only if said modifications are
 * approved by 3Dconnexion.
 *
 */

#ifndef SIAPP_H
#define SIAPP_H


static char SiAppCvsId[]="(c) 1998-2005 3Dconnexion: $Id: siapp.h,v 1.3 2001/01/16 01:18:49 HJin Exp $";

#ifdef __cplusplus
extern "C" {
#endif


/* some enumerated types used in siapp.c */

enum InitResult 
   {
   NOT_LOADED, 
   FAILED, 
   LOADED
   };

enum ErrorCode 
   {
   NO_DLL_ERROR=0,
   DLL_LOAD_FAILURE,
   DLL_FUNCTION_LOAD_FAILURE,
   DLL_VAR_LOAD_FAILURE
   };


/* externally used functions */

enum SpwRetVal _cdecl SiInitialize(void);
void           _cdecl SiTerminate(void);
int            _cdecl SiGetNumDevices (void);
SiDevID        _cdecl SiDeviceIndex (int idx);
int            _cdecl SiDispatch (SiHdl hdl, SiGetEventData *pData,
                           SiSpwEvent *pEvent, SiSpwHandlers *pDHandlers);
void           _cdecl SiOpenWinInit (SiOpenData *pData, HWND hWnd);
SiHdl          _cdecl SiOpen (char *pAppName, SiDevID devID, SiTypeMask *pTMask, int mode, 
                       SiOpenData *pData);
enum SpwRetVal _cdecl SiClose (SiHdl hdl);
void           _cdecl SiGetEventWinInit (SiGetEventData *pData,
                                  UINT msg, WPARAM wParam, LPARAM lParam);
enum SpwRetVal _cdecl SiGetEvent (SiHdl hdl, int flags, SiGetEventData *pData, 
                           SiSpwEvent *pEvent);
enum SpwRetVal _cdecl SiBeep (SiHdl hdl, char *string);
enum SpwRetVal _cdecl SiRezero (SiHdl hdl);
enum SpwRetVal _cdecl SiGrabDevice (SiHdl hdl, SPWbool exclusive);
enum SpwRetVal _cdecl SiReleaseDevice (SiHdl hdl);
int            _cdecl SiButtonPressed (SiSpwEvent *pEvent);
int            _cdecl SiButtonReleased (SiSpwEvent *pEvent);
enum SpwRetVal _cdecl SiSetUiMode (SiHdl hdl, SPWuint32 mode);
enum SpwRetVal _cdecl SiSetTypeMask (SiTypeMask *pTMask, int type1, ...);
enum SpwRetVal _cdecl SiGetDevicePort (SiDevID devID, SiDevPort *pPort);
enum SpwRetVal _cdecl SiGetDriverInfo (SiVerInfo *pInfo);
void           _cdecl SiGetLibraryInfo (SiVerInfo *pInfo);
enum SpwRetVal _cdecl SiGetDeviceInfo (SiHdl hdl, SiDevInfo *pInfo);
char *         _cdecl SpwErrorString (enum SpwRetVal val);
enum SpwRetVal _cdecl SiSyncSendQuery(SiHdl hdl);
enum SpwRetVal _cdecl SiSyncGetVersion(SiHdl hdl, SPWuint32 *pmajor, SPWuint32 *pminor);
enum SpwRetVal _cdecl SiSyncGetNumberOfFunctions(SiHdl hdl, SPWuint32 *pnumberOfFunctions);
enum SpwRetVal _cdecl SiSyncGetFunction(SiHdl hdl, SPWuint32 index, SPWint32 *pabsoluteFunctionNumber, WCHAR name[], SPWuint32 *pmaxNameLen);
enum SpwRetVal _cdecl SiSyncGetButtonAssignment(SiHdl hdl, SPWuint32 buttonNumber, SPWint32 *passignedFunctionIndex);
enum SpwRetVal _cdecl SiSyncSetButtonAssignment(SiHdl hdl, SPWuint32 buttonNumber, SPWint32 functionIndex);
enum SpwRetVal _cdecl SiSyncSetButtonAssignmentAbsolute(SiHdl hdl, SPWuint32 buttonNumber, SPWint32 absoluteFunctionNumber );
enum SpwRetVal _cdecl SiSyncSetButtonName(SiHdl hdl, SPWuint32 buttonNumber, WCHAR name[]);
enum SpwRetVal _cdecl SiSyncGetAxisLabel (SiHdl hdl, SPWuint32 axisNumber, WCHAR name[], SPWuint32 *pmaxNameLen );
enum SpwRetVal _cdecl SiSyncSetAxisLabel (SiHdl hdl, SPWuint32 axisNumber, WCHAR name[] );
enum SpwRetVal _cdecl SiSyncGetOrientation (SiHdl hdl, SPWint32 axes[6] );
enum SpwRetVal _cdecl SiSyncSetOrientation (SiHdl hdl, SPWint32 axes[6] );
enum SpwRetVal _cdecl SiSyncGetFilter (SiHdl hdl, SiSyncFilter i, SiSyncFilterValue *pv );
enum SpwRetVal _cdecl SiSyncSetFilter (SiHdl hdl, SiSyncFilter i, SiSyncFilterValue v );
enum SpwRetVal _cdecl SiSyncGetAxesState (SiHdl hdl, SiSyncAxesState *pa );
enum SpwRetVal _cdecl SiSyncSetAxesState (SiHdl hdl, SiSyncAxesState a );
enum SpwRetVal _cdecl SiSyncSetInfoLine (SiHdl hdl, SPWint32 duration, WCHAR text[] );
enum SpwRetVal _cdecl SiSyncGetScaleOverall (SiHdl hdl, SPWfloat32 *pv );
enum SpwRetVal _cdecl SiSyncSetScaleOverall (SiHdl hdl, SPWfloat32 v );
enum SpwRetVal _cdecl SiSyncGetScaleTx (SiHdl hdl, SPWfloat32 *pv );
enum SpwRetVal _cdecl SiSyncSetScaleTx (SiHdl hdl, SPWfloat32 v );
enum SpwRetVal _cdecl SiSyncGetScaleTy (SiHdl hdl, SPWfloat32 *pv );
enum SpwRetVal _cdecl SiSyncSetScaleTy (SiHdl hdl, SPWfloat32 v );
enum SpwRetVal _cdecl SiSyncGetScaleTz (SiHdl hdl, SPWfloat32 *pv );
enum SpwRetVal _cdecl SiSyncSetScaleTz (SiHdl hdl, SPWfloat32 v );
enum SpwRetVal _cdecl SiSyncGetScaleRx (SiHdl hdl, SPWfloat32 *pv );
enum SpwRetVal _cdecl SiSyncSetScaleRx (SiHdl hdl, SPWfloat32 v );
enum SpwRetVal _cdecl SiSyncGetScaleRy (SiHdl hdl, SPWfloat32 *pv );
enum SpwRetVal _cdecl SiSyncSetScaleRy (SiHdl hdl, SPWfloat32 v );
enum SpwRetVal _cdecl SiSyncGetScaleRz (SiHdl hdl, SPWfloat32 *pv );
enum SpwRetVal _cdecl SiSyncSetScaleRz (SiHdl hdl, SPWfloat32 v );
enum SpwRetVal _cdecl SiSyncInvokeAbsoluteFunction (SiHdl hdl, SiSyncAbsFunctionNumber i );
enum SpwRetVal _cdecl SiSyncSetButtonState (SiHdl hdl, SPWuint32 buttonNumber, SiSyncButtonState state );
enum SpwRetVal _cdecl SiGetButtonName (SiHdl hdl, SPWuint32 buttonNumber, SiButtonName *pname);
enum SpwRetVal _cdecl SiGetDeviceName (SiHdl hdl, SiDeviceName *pname);
enum SpwRetVal _cdecl SiGetDeviceImageFileName (SiHdl hdl, char name[], SPWuint32 *pmaxNameLen);
HICON          _cdecl SiGetCompanyIcon(void);
enum SpwRetVal _cdecl SiGetCompanyLogoFileName (char name[], SPWuint32 *pmaxNameLen);

#ifdef __cplusplus
}
#endif

#endif /* #ifndef SIAPP_H */
