//Implementierung zu X_3DMouse.h

#include "stdafx.h"
#include "X_3DMouse.h"
#include "ChildView.h"
#include "HexMotion.h"
#include "Resource.h"

//statische Variable
C3DMouse*	C3DMouse::m_pC3DMouse;				//statischer pointer auf Instanz


//Konstruktor
C3DMouse::C3DMouse()
{
	TRACE("C3DMouse::C3DMouse()\n"); //Statusausgabe fr Debugzwecke
	m_pC3DMouse=this;
	Init3DMouse();
}

//Destruktor
C3DMouse::~C3DMouse()
{
	TRACE("C3DMouse::~C3DMouse()\n"); //Statusausgabe fr Debugzwecke
	Terminate3DMouse(); //added by S.Wei, last change 29.10.2007
}


// -- Methoden --

//following methode added by S.Wei 17.09.2007
void C3DMouse::Init3DMouse()
{
	CChildView * pCVWnd = (CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView");
	// file:///C:/Programme/3Dconnexion/3Dconnexion%203DxWare%20SDK/doc/Index.htm
	SiOpenData	device_3DMouse;		/* Plattform-specific device data */
    
	SiInitialize();
	SiOpenWinInit(&device_3DMouse, pCVWnd->m_hWnd);
	if ( (hdl_3DMouse = SiOpen ("hexapod", SI_ANY_DEVICE, SI_NO_MASK, SI_EVENT, &device_3DMouse)) == SI_NO_HANDLE)
    {
		/* Get initialization error */
		MessageBox(pCVWnd->m_hWnd,"Could not open a 3DxWare device", NULL, MB_ICONSTOP | MB_OK);
		SiTerminate (); // Shut down the 3DxWare input library
    }
	else
	{
		SiSetUiMode (&hdl_3DMouse, SI_UI_ALL_CONTROLS);
		is3DMouseOn = true;
	}
}

//following methode added by S.Wei 25.09.2007
void C3DMouse::Terminate3DMouse()
{
	if(is3DMouseOn)
	{
		SiTerminate ();
		is3DMouseOn = false;
	}
}

//following methode added by S.Wei 17.09.2007, last change 12.02.2008
/*Methode for 3DMouse events*/
void C3DMouse::On3DMouse(SiSpwEvent event_3DMouse, SiGetEventData eventData_3DMouse)
{
	CChildView * m_pCVWnd = (CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView");
	switch (event_3DMouse.type)
	{
		case SI_MOTION_EVENT:
			//Bewegungen
			float faktor;
			
			SiSpwData *ssp;
			ssp = &event_3DMouse.u.spwData;
			
			if(ssp->mData[0] < -x3DMouse_THRESHOLD)
			{//Linksbewegung
				faktor = 1.0f * -ssp->mData[0] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_X_LEFT, faktor);
			}
			if(ssp->mData[0] > x3DMouse_THRESHOLD)
			{//Rechtsbewegung
				faktor = 1.0f * ssp->mData[0] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_X_RIGHT, faktor);
			}
			if(ssp->mData[1] < -x3DMouse_THRESHOLD)
			{//runter
				faktor = 1.0f * -ssp->mData[1] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_Y_DOWN, faktor);
			}
			if(ssp->mData[1] > x3DMouse_THRESHOLD)
			{//hoch
				faktor = 1.0f * ssp->mData[1] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_Y_UP, faktor);
			}
			if(ssp->mData[2] < -x3DMouse_THRESHOLD)
			{//vor
				faktor = 1.0f * -ssp->mData[2] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_Z_FRONT, faktor);
			}
			if(ssp->mData[2] > x3DMouse_THRESHOLD)
			{//zurck
				faktor = 1.0f * ssp->mData[2] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_Z_BACK, faktor);
			}
			if(ssp->mData[5] < -x3DMouse_THRESHOLD)
			{//links runter
				faktor = 1.0f * -ssp->mData[5] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_TRN_Z_1, faktor);
			}
			if(ssp->mData[5] > x3DMouse_THRESHOLD)
			{//rechts runter
				faktor = 1.0f * ssp->mData[5] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_TRN_Z_2, faktor);
			}
			if(ssp->mData[4] < -x3DMouse_THRESHOLD)
			{//links hinter drehen 
				faktor = 1.0f * -ssp->mData[4] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_TRN_Y_2, faktor);
			}
			if(ssp->mData[4] > x3DMouse_THRESHOLD)
			{//rechts hinter drehen
				faktor = 1.0f * ssp->mData[4] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_TRN_Y_1, faktor);
			}
			if(ssp->mData[3] < -x3DMouse_THRESHOLD)
			{//zurck - Drehung
				faktor = 1.0f * -ssp->mData[3] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_TRN_X_2, faktor);
			}
			if(ssp->mData[3] > x3DMouse_THRESHOLD)
			{//vor - Drehung
				faktor = 1.0f * ssp->mData[3] / 840;
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_TRN_X_1, faktor);
			}
			break;

		case SI_BUTTON_EVENT:
			if(event_3DMouse.u.spwData.bData.current == 512) //Taste 9
			{
				//Nullstellung
				m_pCVWnd->ActionFromInteractionDevice(ID_BTN_CENTER_ZERO);
			}
			break;

		default:
			break;
	}
}

/*************** Methode zum berwachen eintreffender Nachrichten, added by S.Wei 17.09.2007*************/
BOOL C3DMouse::PreTranslateMessage(MSG* pMsg)
{
	SiSpwEvent event; /* 3DxWare Event */
	SiGetEventData eData; /* 3DxWare Event Data */

	SiGetEventWinInit (&eData, pMsg->message, pMsg->wParam, pMsg->lParam);

	if (SiGetEvent (hdl_3DMouse, 0, &eData, &event) == SI_IS_EVENT)
	{ //3DxWare event
		On3DMouse(event, eData);
		return true;
	}
	else
	{
		return false;
	}
}